=== doc/requirements.txt ===
sphinx >= 5.3, < 9
sphinx-rtd-theme >= 1.2, < 4
