=== debian/changelog ===
open62541 (1.4.11.1-1) unstable; urgency=medium

  * New upstream release (fixes CVE-2024-53429)

  * Enable Salsa-CI pipeline for the package

  * debian/control:
    - Change depends for libopen62541-1.4-tools from python to
      python:any to make multi-arch friendly.
    - Update standards-version to 4.7.2, no changes needed.

  * debian/copyright:  Update for the new upstream release.

  * debian/symbols:  Update for new upstream release.

  * debian/rules:  Enable hardening compiler flags.

  * debian/patches:
    - More hardening flags.
    - Also use the stack-protector flags for compiling the
      generated ns0 code.

 -- Julius Pfrommer <julius.pfrommer@web.de>  Mon, 24 Mar 2025 20:56:25 +0100

open62541 (1.4.8-1) unstable; urgency=low

  * Initial release (closes: #985909)

 -- Julius Pfrommer <julius.pfrommer@web.de>  Thu, 28 Nov 2024 10:50:27 +0100
