=== debian/control ===
Source: open62541
Priority: optional
Maintainer: Julius Pfrommer <julius.pfrommer@web.de>
Build-Depends: debhelper-compat (= 13), cmake (>= 3.13), python3 (>= 3.7), libmbedtls-dev (>= 2.28.0)
Rules-Requires-Root: no
Standards-Version: 4.7.2
Section: libs
Homepage: https://open62541.org/
Vcs-Git: https://salsa.debian.org/jpfr/open62541.git
Vcs-Browser: https://salsa.debian.org/jpfr/open62541

Package: libopen62541-1.4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: implementation of OPC UA (IEC 62541)
 open62541 provides the necessary tools to implement dedicated OPC UA clients
 and servers, or to integrate OPC UA-based communication into existing
 applications.

Package: libopen62541-1.4-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libopen62541-1.4 (= ${binary:Version}), ${misc:Depends}, libmbedtls-dev
Description: implementation of OPC UA (IEC 62541) - development
 Contains the header files for the development of C-based applications with the
 open62541 library.

Package: libopen62541-1.4-tools
Section: libdevel
Architecture: all
Depends: ${misc:Depends}, python3:any
Recommends: libopen62541-1.4-dev
Description: implementation of OPC UA (IEC 62541) - tools and nodeset-compiler
 Contains tools for the use with the open62541 library. For example the
 nodeset-compiler and the generation of self-signed application certificates.
