=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_auto_configure:
	dh_auto_configure -- \
        -DBUILD_SHARED_LIBS=ON \
        -DCMAKE_C_VISIBILITY_PRESET=hidden \
        -DCMAKE_BUILD_TYPE=RelWithDebInfo \
        -DUA_NAMESPACE_ZERO=FULL \
        -DUA_NODESET_DIR=$(CURDIR)/nodeset \
        -DUA_ENABLE_DATATYPES_ALL=ON \
        -DUA_ENABLE_HARDENING=ON \
        -DUA_ENABLE_ENCRYPTION="MBEDTLS" \
        -DUA_ENABLE_PUBSUB=ON \
        -DUA_ENABLE_PUBSUB_ENCRYPTION=ON \
        -DUA_ENABLE_PUBSUB_INFORMATIONMODEL=ON \
        -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)"

override_dh_auto_test:
	dh_auto_test -- ARGS+=--output-on-failure

%:
	dh $@ --buildsystem=cmake
