=== debian/watch ===
version=4
opts="searchmode=plain, \
    uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/, \
    downloadurlmangle=s%https://api.github.com/repos/open62541/open62541/tarball/v?@ANY_VERSION@%https://github.com/open62541/open62541/archive/refs/tags/v$1.tar.gz%, \
    filenamemangle=s%.*/v?@ANY_VERSION@%@PACKAGE@-v$1.tar.gz%" \
    https://api.github.com/repos/open62541/open62541/releases?per_page=50 \
    https://api.github.com/repos/open62541/open62541/tarball/v?@ANY_VERSION@ 
opts="component=nodeset" \
    https://github.com/OPCFoundation/UA-Nodeset/tags?after=LADS-1.0.0-2023-11-30 \
    .*(Machinery-1.03.0-2023-08-01)\.tar\.gz ignore uupdate
